Bug 98605 - Typed arrays should not be 20x slower in the baseline JIT than in the DFG JIT
Summary: Typed arrays should not be 20x slower in the baseline JIT than in the DFG JIT
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: JavaScriptCore (show other bugs)
Version: 528+ (Nightly build)
Hardware: All All
: P2 Normal
Assignee: Filip Pizlo
URL:
Keywords:
Depends on: 97288 98855 98856
Blocks:
  Show dependency treegraph
 
Reported: 2012-10-06 15:53 PDT by Filip Pizlo
Modified: 2012-10-10 21:41 PDT (History)
7 users (show)

See Also:


Attachments
work in progress, not rebased (336.67 KB, patch)
2012-10-08 19:24 PDT, Filip Pizlo
no flags Details | Formatted Diff | Diff
the patch (47.06 KB, patch)
2012-10-09 17:25 PDT, Filip Pizlo
oliver: review+
webkit-ews: commit-queue-
Details | Formatted Diff | Diff
patch for landing (50.84 KB, patch)
2012-10-09 17:53 PDT, Filip Pizlo
buildbot: commit-queue-
Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Filip Pizlo 2012-10-06 15:53:30 PDT
It's OK for the baseline JIT to be 2-4x slower than the DFG.  But anything more than that makes me unhappy.

Note that this depends on the baselineJIT get_by_val/put_by_val patching machinery from https://bugs.webkit.org/show_bug.cgi?id=97288
Comment 1 Filip Pizlo 2012-10-08 19:24:35 PDT
Created attachment 167673 [details]
work in progress, not rebased

This patch doesn't quite work yet (but it's already a >30% speed-up on some programs).  It also includes all changes from an earlier version of https://bugs.webkit.org/show_bug.cgi?id=97288.  I'll have to somehow rebase once that other thing lands.
Comment 2 Filip Pizlo 2012-10-09 17:25:59 PDT
Created attachment 167879 [details]
the patch
Comment 3 Gavin Barraclough 2012-10-09 17:43:30 PDT
Comment on attachment 167879 [details]
the patch

r is me, too
Comment 4 Early Warning System Bot 2012-10-09 17:43:54 PDT
Comment on attachment 167879 [details]
the patch

Attachment 167879 [details] did not pass qt-ews (qt):
Output: http://queues.webkit.org/results/14215948
Comment 5 Early Warning System Bot 2012-10-09 17:50:10 PDT
Comment on attachment 167879 [details]
the patch

Attachment 167879 [details] did not pass qt-wk2-ews (qt):
Output: http://queues.webkit.org/results/14221905
Comment 6 Filip Pizlo 2012-10-09 17:53:53 PDT
Created attachment 167885 [details]
patch for landing

this should fix the other platforms.
Comment 7 Build Bot 2012-10-09 18:52:17 PDT
Comment on attachment 167885 [details]
patch for landing

Attachment 167885 [details] did not pass win-ews (win):
Output: http://queues.webkit.org/results/14250131
Comment 8 Filip Pizlo 2012-10-09 19:15:08 PDT
Landed with Windows fixes in http://trac.webkit.org/changeset/130839
Comment 9 Csaba Osztrogonác 2012-10-09 22:18:04 PDT
(In reply to comment #8)
> Landed with Windows fixes in http://trac.webkit.org/changeset/130839

New bug reports to fix the ARM traditional and MIPS assembler:
- https://bugs.webkit.org/show_bug.cgi?id=98855
- https://bugs.webkit.org/show_bug.cgi?id=98856
Comment 11 Csaba Osztrogonác 2012-10-10 21:41:37 PDT
(In reply to comment #10)
> This broke the Qt Linux build <http://build.webkit.org/builders/Qt%20Linux%20MIPS32R2%20LE%20Release/builds/1301/steps/compile-webkit/logs/stdio>

It is only the MIPS Linux build: https://bugs.webkit.org/show_bug.cgi?id=98856 ^^^^^^